﻿namespace TabsStudioSQLComment
{
    class Commands
    {
        public Commands(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte_, CommandsImpl commandsImpl_)
        {
            engine = engine_;
            dte = dte_;
            commandsImpl = commandsImpl_;
            if (!new AddinsCommon.VsVersion(dte).IsExtension())
                RegisterCommands();
        }

        public void QueryStatus(string CmdName, EnvDTE.vsCommandStatusTextWanted NeededText,
                ref EnvDTE.vsCommandStatus StatusOption, ref System.Object CommandText)
        {
            if (NeededText != EnvDTE.vsCommandStatusTextWanted.vsCommandStatusTextWantedNone || CmdName == null)
                return;

            if (CmdName == "TabsStudio.Connect.SetSQLComment" ||
                CmdName == "TabsStudio.Connect.SetSQLCommentFromSelection")
            {
                StatusOption = (EnvDTE.vsCommandStatus)SupportedAndEnabled();
            }
        }

        public void Exec(string CmdName, EnvDTE.vsCommandExecOption ExecuteOption, ref System.Object VariantIn,
            ref System.Object VariantOut, ref bool Handled)
        {
            Handled = false;
            if (ExecuteOption != EnvDTE.vsCommandExecOption.vsCommandExecOptionDoDefault || CmdName == null)
                return;

            if (CmdName == "TabsStudio.Connect.SetSQLComment")
            {
                commandsImpl.SetSQLComment();
                Handled = true;
            }
            if (CmdName == "TabsStudio.Connect.SetSQLCommentFromSelection")
            {
                commandsImpl.SetSQLCommentFromSelection();
                Handled = true;
            }
        }

        private void RegisterCommands()
        {
            EnvDTE80.Commands2 commands = dte.Commands as EnvDTE80.Commands2;
            if (commands == null)
                return;

            RegisterCommand(commands, engine.GetAddIn(), "SetSQLComment", "Set SQL Comment",
                "Set SQL comment for the selected tab");
            RegisterCommand(commands, engine.GetAddIn(), "SetSQLCommentFromSelection", "Set SQL Comment from selection",
                "Set SQL comment for the selected tab from the text selection in the active document");
        }

        private void RegisterCommand(EnvDTE80.Commands2 commands, EnvDTE.AddIn addin,
            string name, string buttonText, string tooltip)
        {
            try
            {
                object[] contextGUIDS = new object[] { };
                commands.AddNamedCommand2(addin, name, buttonText, tooltip,
                    true, 36, ref contextGUIDS,
                    (int)SupportedAndEnabled(),
                    (int)EnvDTE80.vsCommandStyle.vsCommandStylePictAndText,
                    EnvDTE80.vsCommandControlType.vsCommandControlTypeButton);
            }
            catch (System.ArgumentException)
            {
                // Command already exists.
            }
        }

        private int SupportedAndEnabled()
        {
            return (int)EnvDTE.vsCommandStatus.vsCommandStatusSupported +
                (int)EnvDTE.vsCommandStatus.vsCommandStatusEnabled;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private EnvDTE80.DTE2 dte;
        private CommandsImpl commandsImpl;
    }
}
